import { Button, Descriptions, Badge, Popconfirm, Row, Col, Form, Input, Select, Table } from 'antd';
import React from 'react';
import { initFilter, extendRule, extendInclude, extendIgnoreDataRule, setDataFieldValue, showApprove, guid, initQueryFilter, ShowDateTime, ShowPrintClose } from '../../../utils/common';
import ReactToPrint from 'react-to-print';
import { ExportToExcel } from '@woowalker/feui'
import XLSX from 'xlsx';
import { connect } from 'dva';
import moment from 'moment';
import { message } from 'antd/lib/index';
import styles from '../HI/StepForm.css';
import config from '../../../config.js';
import FormPage from '../../FormPage'
class CM036ShowPrint extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            data: null,
            btndisplay: 'none',
            isCheck: false, //是否待办 审批
        }
    }

    componentDidMount() {
        if (this.props.data?.id)
            this.loadData(this.props.data?.id);
    }

    componentWillReceiveProps(NextProps) {
        if (NextProps.data?.id && this.props.data?.id != NextProps.data?.id) {
            this.loadData(NextProps.data?.id);
        }
    }

    onTableBtnExport() {
        let TableWrap = document.getElementById('table1');
        let Table = TableWrap.getElementsByTagName('table1')[0];
        const wb = XLSX.utils.table_to_book(Table);
        XLSX.writeFile(wb, this.props.record.Nav_Department.NAME + '.xlsx')

    }

    onClickApprove = (appVisible) => {
        const newtmpData = {
            data: { id: this.props.data.id, isShow: true, key: guid(), param: this.props.data.param, appVisible: appVisible, BtnAgreeDisplay: 'none' },
            formCode: 'PF123',
        }
        this.setState({
            tmpData: newtmpData,
        });
    }
    loadData = (id) => {
        var isCheck = (this.props.data.tableKey != undefined && this.props.data.tableKey == '1') ? true : false
        var orgId = this.props.login ? this.props.login.OrgId : '';
        let json = initFilter(orgId);
        extendRule(json, 'ID', 1, id);
        extendInclude(json, 'Nav_Record')
        extendInclude(json, 'Nav_Record.Nav_UserManage')
        extendInclude(json, 'Nav_Record.Nav_ListUserEstimate.Nav_User')
        extendInclude(json, 'Nav_ListEstimateRecord.Nav_Item')
        extendIgnoreDataRule(json)
        this.props.dispatch({
            type: 'app/getDataByPost',
            payload: json,
            url: 'CM/CMDrillEstimate/GetOrder',
            onComplete: (ret) => {
                if (ret) {
                    this.setState({
                        data: ret,
                        isCheck: isCheck
                    })
                }
            }
        });
    }
    sign = () => {
        let json = initFilter(this.props.login.OrgId, this.props.data.id, null, null, null, this.props.data.TaskID);
        extendRule(json, 'ID', 1, this.props.data.id);
        extendRule(json, 'Parameter1', 1, this.props.data.TaskID)
        extendIgnoreDataRule(json)
        this.props.dispatch({
            type: 'app/getDataByPost',
            payload: json,
            url: 'CM/CMDrillEstimate/Check',
            onComplete: (ret) => {
                ShowPrintClose(this.props)
            }
        });
    }
    render() {
        const { data, isCheck } = this.state;
        const enums = this.props.data.enums ? this.props.data.enums : this.props.app.enums;
        return <div>
            <div style={{ padding: '10px' }}>
                <table>
                    <tr>
                        {/* <td><Button onClick={() => this.onClickApprove(true)} style={{ marginRight: '8px' }} icon='export'>审批详情</Button></td> */}
                        <td><ReactToPrint trigger={() => <Button type={'default'} icon={'printer'} >打印</Button>} content={() => this.componentRef} pageStyle={"#tableId" + this.props.data.id + " { padding:0 40px;} img{width :120px}"} /></td>
                        <td><ExportToExcel fileName='应急演练活动评估' tableId={'tableId' + this.props.data.id} /></td>
                        {isCheck ? <td><Button type={'primary'} icon={'check'} onClick={() => this.sign()} >确认</Button>  </td> : null}
                    </tr>
                </table>
            </div>
            <FormPage {...this.state.tmpData} />
            <div ref={el => (this.componentRef = el)} style={{ padding: '20px', paddingTop: '20px' }} id={'tableId' + this.props.data.id}>
                <h1 className={styles.showPrintHead}>应急演练活动评估</h1>
                {
                    data ? <div style={{ width: '95%' }}>
                        <Descriptions title='' size='middle' bordered>
                            <Descriptions.Item label="编号">{data.CODE}</Descriptions.Item>
                            <Descriptions.Item label="演练主题">{data.Nav_Record.NAME}</Descriptions.Item>
                            <Descriptions.Item label="演练时间">{data.Nav_Record.TIME}</Descriptions.Item>
                            <Descriptions.Item label="演练地点">{data.Nav_Record.PLACE}</Descriptions.Item>
                            <Descriptions.Item label="演练方式">{enums.CMDrillMethodEnum.enums[data.Nav_Record.METHOD]}</Descriptions.Item>
                            <Descriptions.Item label="现场总指挥">{data.Nav_Record.Nav_UserManage.NAME}</Descriptions.Item>
                            <Descriptions.Item label="评估人员">{data?.Nav_Record?.Nav_ListUserEstimate?.map((item, i) => {
                                return (item.ISAGREE == true ? ((i > 0 ? ',' : '') + item.Nav_User.NAME) : <a style={{ color: "red" }} >{(i > 0 ? ',' : '') + item.Nav_User.NAME}</a>)
                            })}</Descriptions.Item>
                            <Descriptions.Item label="其他改进方面">{data.ADVISE}</Descriptions.Item>
                        </Descriptions>
                    </div> : null
                }
                {
                    (data?.Nav_ListEstimateRecord && data?.Nav_ListEstimateRecord.length > 0) ?
                        <table className={styles.PrintFormLight}>
                            <tbody>
                                <tr>
                                    <td colSpan={3} className={styles.showPrintHead2}>应急演练活动评估项目</td>
                                </tr>
                                <tr className={styles.PrintFormLightTh}>
                                    <td>评估项目</td>
                                    <td>评价结果</td>
                                    <td>建议</td>
                                </tr>
                                {data?.Nav_ListEstimateRecord?.map((item, i) => {
                                    return <tr>
                                        <td>{item.Nav_Item.NAME} </td>
                                        <td>{enums.CMEvaluateStatusEnum.enums[item.SCORE]} </td>
                                        <td>{item.ADVISE} </td>
                                    </tr>
                                })}
                            </tbody>
                        </table>
                        : null
                }
            </div>
        </div>
    }
}
export default connect(({ login, app }) => ({ login, app }))(CM036ShowPrint) 
